org.apache.bcel.classfile

## Class Synthetic

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.Synthetic

- All Implemented Interfaces:
    Cloneable, Node

      public final class Synthetic
      extends Attribute

  This class is derived from Attribute and declares this class as 'synthetic', i.e., it needs special handling. The JVM specification states "A class member that does not appear in the source code must be marked using a Synthetic attribute." It may appear in the ClassFile attribute table, a field_info table or a method_info table. This class is intended to be instantiated from the Attribute.readAttribute() method.
  See Also:
    `Attribute`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, EMPTY_ARRAY, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Synthetic(int nameIndex, int length, byte[] bytes, ConstantPool constantPool)`
    `Synthetic(Synthetic c)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool constantPool)`
    `void` | `dump(DataOutputStream file)` Dump source file attribute to file stream in binary format.
    `byte[]` | `getBytes()`
    `void` | `setBytes(byte[] bytes)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Synthetic

          public Synthetic(int nameIndex,
                           int length,
                           byte[] bytes,
                           ConstantPool constantPool)

      Parameters:
        `nameIndex` - Index in constant pool to CONSTANT_Utf8, which should represent the string "Synthetic".
        `length` - Content length in bytes - should be zero.
        `bytes` - Attribute contents
        `constantPool` - The constant pool this attribute is associated with.

    - #### Synthetic

          public Synthetic(Synthetic c)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.
      Parameters:
        `c` - Source to copy.

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### copy

          public Attribute copy(ConstantPool constantPool)

      Specified by:
        `copy` in class `Attribute`
      Parameters:
        `constantPool` - constant pool to save.
      Returns:
        deep copy of this attribute

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dump source file attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException` - if an I/O error occurs.

    - #### getBytes

          public byte[] getBytes()

      Returns:
        data bytes.

    - #### setBytes

          public void setBytes(byte[] bytes)

      Parameters:
        `bytes` -

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation.

Copyright © 2004–2022 The Apache Software Foundation. All rights reserved.